//+------------------------------------------------------------------+
//|                                                   FIR_Filter.mq4 |
//|                                           Copyright  2006, gpwr |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, gpwr"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_width1 2

//Global constants
#define pi 3.141592653589793238462643383279502884197169399375105820974944592

//Input parameters
extern int  Per     =51;  // # of filter taps (odd)
extern int  Window  =2;   // selects windowing function

// Global parameters
double w[];

//Indicator buffers
double FIRMA[];

int init()
{
   ArrayResize(w,Per);
   double wsum=0.0;
   for(int k=0;k<Per;k++)
   {
      double a=2.0*pi*(k+1)/(Per+1);
      switch(Window){
      case 1:  w[k]=1.0;break;//Rectangular window
      case 2:  w[k]=0.50-0.50*MathCos(a);break;//Hann window
      case 3:  w[k]=0.54-0.46*MathCos(a);break;//Hamming window
      case 4:  w[k]=0.42-0.50*MathCos(a)+0.08*MathCos(2.0*a);break;//Blackman window
      case 5:  w[k]=0.35875-0.48829*MathCos(a)+0.14128*MathCos(2.0*a)-0.01168*MathCos(3.0*a);break;//Blackman-Harris window 
      case 6:  w[k]=0.355768-0.487396*MathCos(a)+0.144232*MathCos(2.0*a)-0.012604*MathCos(3.0*a);break;//Nuttall window
      case 7:  w[k]=0.3635819-0.4891775*MathCos(a)+0.1365995*MathCos(2.0*a)-0.0106411*MathCos(3.0*a);break;//Blackman-Nuttall window
      default: w[k]=1;break;}//Rectangular window 
      wsum+=w[k];
   }
   for(k=0;k<Per;k++) w[k]/=wsum;
   
   ArrayInitialize(FIRMA,EMPTY_VALUE);
   IndicatorBuffers(1);
   SetIndexBuffer(0,FIRMA);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   IndicatorShortName("FIRMA");
   SetIndexShift(0,-(Per-1)/2);
   return(0);
}

int deinit(){return(0);}

int start()
{
   int i=Bars-1-IndicatorCounted();
   while(i>=0)
   {
      if(i<=Bars-Per)
      {
         FIRMA[i]=0.0;
         for(int k=0;k<Per;k++) FIRMA[i]+=Close[i+k]*w[k];
      }
      i--;
   }
  return(0);
}
//+------------------------------------------------------------------+